--triggers for District table updates and deletes


CREATE OR REPLACE FUNCTION district_update_function()
RETURNS trigger AS $$
BEGIN
	
	UPDATE Warehouse SET W_ID = NEW.D_W_ID WHERE W_ID = OLD.D_W_ID;
		
	RETURN NEW;
	

END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER district_update_trigger
AFTER UPDATE ON district
FOR EACH ROW
EXECUTE PROCEDURE district_update_function();


CREATE OR REPLACE FUNCTION district_delete_function()
RETURNS trigger AS $$
BEGIN
	
	DELETE FROM Warehouse WHERE W_ID = OLD.D_W_ID;
			
	RETURN OLD;
	

END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER district_delete_trigger
AFTER DELETE ON district
FOR EACH ROW
EXECUTE PROCEDURE district_delete_function();
