--triggers for History table updates and deletes


CREATE OR REPLACE FUNCTION history_update_function()
RETURNS trigger AS $$
BEGIN
	
	UPDATE Customer SET C_W_ID = NEW.H_C_W_ID WHERE C_W_ID = OLD.H_C_W_ID;
	
	RETURN NEW;
	
	UPDATE Customer SET C_D_ID = NEW.H_C_D_ID WHERE C_D_ID = OLD.H_C_D_ID;
	
	RETURN NEW;
	
	UPDATE Customer SET C_ID = NEW.H_C_ID WHERE C_ID = OLD.H_C_ID;
	
	RETURN NEW;
	
	UPDATE District SET D_W_ID = NEW.H_W_ID WHERE D_W_ID = OLD.H_W_ID;
		
	RETURN NEW;
	
	UPDATE District SET D_ID = NEW.H_D_ID WHERE D_ID = OLD.H_D_ID;
		
	RETURN NEW;
	
	
	
END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER history_update_trigger
AFTER UPDATE ON history
FOR EACH ROW
EXECUTE PROCEDURE history_update_function();


CREATE OR REPLACE FUNCTION history_delete_function()
RETURNS trigger AS $$
BEGIN
	
	DELETE FROM Customer WHERE C_W_ID = OLD.H_C_W_ID;
		
	RETURN OLD;
	
	DELETE FROM District WHERE D_ID = OLD.H_D_ID;
			
	RETURN OLD;
	

END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER history_delete_trigger
AFTER DELETE ON history
FOR EACH ROW
EXECUTE PROCEDURE history_delete_function();
