--triggers for NewOrder table updates and deletes


CREATE OR REPLACE FUNCTION neworder_update_function()
RETURNS trigger AS $$
BEGIN
	
	UPDATE OrderDetails SET OD_W_ID = NEW.NO_W_ID WHERE OD_W_ID = OLD.NO_W_ID;
	
	RETURN NEW;
	
	UPDATE OrderDetails SET OD_D_ID = NEW.NO_D_ID WHERE OD_D_ID = OLD.NO_D_ID;
	
	RETURN NEW;
	
	UPDATE OrderDetails SET OD_ID = NEW.NO_O_ID WHERE OD_ID = OLD.NO_O_ID;
	
	RETURN NEW;
	
	
END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER neworder_update_trigger
AFTER UPDATE ON neworder
FOR EACH ROW
EXECUTE PROCEDURE neworder_update_function();


CREATE OR REPLACE FUNCTION neworder_delete_function()
RETURNS trigger AS $$
BEGIN
	
	DELETE FROM OrderDetails WHERE OD_W_ID = OLD.NO_W_ID;
		
	RETURN OLD;
	
	
END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER neworder_delete_trigger
AFTER DELETE ON neworder
FOR EACH ROW
EXECUTE PROCEDURE neworder_delete_function();
