--triggers for OrderLine table updates and deletes


CREATE OR REPLACE FUNCTION orderline_update_function()
RETURNS trigger AS $$
BEGIN
	
	UPDATE OrderDetails SET OD_W_ID = NEW.OL_W_ID WHERE OD_W_ID = OLD.OL_W_ID;
	
	RETURN NEW;
	
	UPDATE OrderDetails SET OD_D_ID = NEW.OL_D_ID WHERE OD_D_ID = OLD.OL_D_ID;
	
	RETURN NEW;
	
	UPDATE OrderDetails SET OD_ID = NEW.OL_O_ID WHERE OD_ID = OLD.OL_O_ID;
	
	RETURN NEW;
	
	UPDATE Stock SET S_W_ID = NEW.OL_SUPPLY_W_ID WHERE S_W_ID = OLD.OL_SUPPLY_W_ID;
		
	RETURN NEW;
	
	UPDATE Stock SET S_I_ID = NEW.OL_I_ID WHERE S_I_ID = OLD.OL_I_ID;
		
	RETURN NEW;
	
END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER orderline_update_trigger
AFTER UPDATE ON orderline
FOR EACH ROW
EXECUTE PROCEDURE orderline_update_function();


CREATE OR REPLACE FUNCTION orderline_delete_function()
RETURNS trigger AS $$
BEGIN
	
	DELETE FROM OrderDetails WHERE OD_W_ID = OLD.OL_W_ID;
		
	RETURN OLD;
	
	DELETE FROM Stock WHERE S_W_ID = OLD.OL_SUPPLY_W_ID;
			
	RETURN OLD;
	

END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER orderline_delete_trigger
AFTER DELETE ON orderline
FOR EACH ROW
EXECUTE PROCEDURE orderline_delete_function();
