--triggers for Stock table updates and deletes


CREATE OR REPLACE FUNCTION stock_update_function()
RETURNS trigger AS $$
BEGIN
	
	UPDATE Item SET I_ID = NEW.S_I_ID WHERE (I_ID) = OLD.S_I_ID;
	
	RETURN NEW;
	
	UPDATE Warehouse SET W_ID = NEW.S_W_ID WHERE (W_ID) = OLD.S_W_ID;
		
	RETURN NEW;
	

END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER stock_update_trigger
AFTER UPDATE ON stock
FOR EACH ROW
EXECUTE PROCEDURE stock_update_function();


CREATE OR REPLACE FUNCTION stock_delete_function()
RETURNS trigger AS $$
BEGIN
	
	DELETE FROM Item WHERE (I_ID) = OLD.S_I_ID;
		
	RETURN OLD;
	
	DELETE FROM Warehouse WHERE (W_ID) = OLD.S_W_ID;
			
	RETURN OLD;
	

END;
$$ LANGUAGE plpgsql;


CREATE TRIGGER stock_delete_trigger
AFTER DELETE ON stock
FOR EACH ROW
EXECUTE PROCEDURE stock_delete_function();
