--create tables of database



CREATE TABLE Warehouse(
   W_ID serial,
   W_NAME varchar(10),
   W_STREET_1 varchar(20),
   W_STREET_2 varchar(20),
   W_CITY varchar(20),
   W_STATE char(2),
   W_ZIP char(9),
   W_TAX numeric(4,4),
   W_YTD numeric(12,2),
   
   
   PRIMARY KEY( W_ID )
);

CREATE TABLE Stock(
   S_I_ID serial,
   S_W_ID serial,
   S_QUANTITY numeric(4),
   S_DIST_01 char(24),
   S_DIST_02 char(24),
   S_DIST_03 char(24),
   S_DIST_04 char(24),
   S_DIST_05 char(24),
   S_DIST_06 char(24),
   S_DIST_07 char(24),
   S_DIST_08 char(24),
   S_DIST_09 char(24),
   S_DIST_10 char(24),
   S_YTD numeric(8),
   S_ORDER_CNT numeric(4),
   S_REMOTE_CNT numeric(4),
   S_DATA varchar(50),
   
   PRIMARY KEY( S_W_ID, S_I_ID )
   
);

CREATE TABLE Item(
   I_ID serial,
   I_IM_ID serial,
   I_NAME varchar(24),
   I_PRICE numeric(5,2),
   I_DATA varchar(50),
   
   PRIMARY KEY( I_ID )
);

CREATE TABLE History(
   H_C_ID serial,
   H_C_D_ID serial,
   H_C_W_ID serial,
   H_D_ID serial,
   H_W_ID serial,
   H_DATE timestamp,
   H_AMOUNT numeric(6,2),
   H_DATA varchar(24)
   
   --PRIMARY KEY( none )
   
);

CREATE TABLE NewOrder(
   NO_O_ID serial,
   NO_D_ID serial,
   NO_W_ID serial,
   
   PRIMARY KEY( NO_W_ID, NO_D_ID, NO_O_ID )
   
);

CREATE TABLE OrderLine(
   OL_O_ID serial,
   OL_D_ID serial,
   OL_W_ID serial,
   OL_NUMBER serial,
   OL_I_ID serial,
   OL_SUPPLY_W_ID serial,
   OL_DELIVERY_D timestamp,
   OL_QUANTITY numeric(2),
   OL_AMOUNT numeric(6,2),
   OL_DIST_INFO char(24),
   
   PRIMARY KEY( OL_W_ID, OL_D_ID, OL_O_ID, OL_NUMBER )
   
);

CREATE TABLE District(
   D_ID serial,
   D_W_ID serial,
   D_NAME varchar(10),
   D_STREET_1 varchar(20),
   D_STREET_2 varchar(20),
   D_CITY varchar(20),
   D_STATE char(2),
   D_ZIP char(9),
   D_TAX numeric(4,4),
   D_YTD numeric(12,2),
   D_NEXT_O_ID serial,
   
   PRIMARY KEY( D_W_ID, D_ID )
   
);

CREATE TABLE Customer(
   C_ID serial,
   C_D_ID serial,
   C_W_ID serial,
   C_FIRST varchar(16),
   C_MIDDLE char(2),
   C_LAST varchar(16),
   C_STREET_1 varchar(20),
   C_STREET_2 varchar(20),
   C_CITY varchar(20),
   C_STATE char(2),
   C_ZIP char(9),
   C_PHONE char(16),
   C_SINCE timestamp,
   C_CREDIT char(2),
   C_CREDIT_LIM numeric(12,2),
   C_DISCOUNT numeric(4,4),
   C_BALANCE numeric(12,2),
   C_YTD_PAYMENT numeric(12,2),
   C_PAYMENT_CNT numeric(4),
   C_DELIVERY_CNT numeric(4),
   C_DATA varchar(500),
   
   
   PRIMARY KEY( C_W_ID, C_D_ID, C_ID )
   
   
);

CREATE TABLE OrderDetails(
   OD_ID serial,
   OD_D_ID serial,
   OD_W_ID serial,
   OD_C_ID serial,
   OD_ENTRY_D timestamp,
   OD_CARRIER_ID serial,
   OD_OL_CNT numeric(2),
   OD_ALL_LOCAL numeric(1),
   
   PRIMARY KEY( OD_W_ID, OD_D_ID, OD_ID )
   
);





