

import random
class Table:
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnName = None
		self.IDName = None
		self.FunctName = None
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'
	
	def StringPrint(self):
		if (self.TransactionType == 1):
			return(self.UpdateString % (self.TableName, self.ColumnName, self.FunctName, self.IDName))
		else:
			return(self.DeleteString % (self.TableName, self.IDName))
	
class Warehouse(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['W_NAME', 'W_STREET_1', 'W_STREET_2', 'W_CITY', 'W_STATE', 'W_ZIP', 'W_TAX', 'W_YTD']
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'W_ID'
		self.FunctionMap = {'W_NAME' : 'string_creation(10)',
						'W_STREET_1' : '(string_number_creation(4) + string_creation(16))',
						'W_STREET_2' : 'string_creation(20)',
						'W_CITY' : 'string_creation(20)',
						'W_STATE' : 'string_creation(2)',
						'W_ZIP' : 'string_number_creation(9)',
						'W_TAX' : 'random_number_generator_4_4_precision(.0001, .9999)',
						'W_YTD' : 'random_number_generator_12_2_precision(-9999999999.99, 9999999999.99)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'
	
class Stock(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['S_QUANTITY', 'S_DIST_01', 'S_DIST_02', 'S_DIST_03', 'S_DIST_04', 'S_DIST_05', 'S_DIST_06', 'S_DIST_07', 'S_DIST_08', 'S_DIST_09', 'S_DIST_10', 'S_YTD', 'S_ORDER_CNT', 'S_REMOTE_CNT', 'S_DATA']
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'S_I_ID'
		self.FunctionMap = {'S_QUANTITY' : 'random_number_generator_4_precision(-9999, 9999)',
						'S_DIST_01' : 'string_creation(24)',
						'S_DIST_02' : 'string_creation(24)',
						'S_DIST_03' : 'string_creation(24)',
						'S_DIST_04' : 'string_creation(24)',
						'S_DIST_05' : 'string_creation(24)',
						'S_DIST_06' : 'string_creation(24)',
						'S_DIST_07' : 'string_creation(24)',
						'S_DIST_08' : 'string_creation(24)',
						'S_DIST_09' : 'string_creation(24)',
						'S_DIST_10' : 'string_creation(24)',
						'S_YTD' : 'random_number_generator_8_precision(-99999999, 99999999)',
						'S_ORDER_CNT' : 'random_number_generator_4_precision(-9999, 9999)',
						'S_REMOTE_CNT' : 'random_number_generator_4_precision(-9999, 9999)',
						'S_DATA' : 'string_creation(50)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'
	
class Item(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['I_NAME', 'I_PRICE', 'I_DATA']	
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'I_ID'
		self.FunctionMap = {'I_NAME' : 'string_creation(24)',
						'I_PRICE' : 'random_number_generator_5_2_precision(000.01, 999.99)',
						'I_DATA' : 'string_creation(50)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'
	
class History(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['H_DATE', 'H_AMOUNT', 'H_DATA']	
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'H_C_ID'
		self.FunctionMap = {'H_DATE' : 'CURRENT_TIMESTAMP',
						'H_AMOUNT' : 'random_number_generator_6_2_precision(-9999.99, 9999.99)',
						'H_DATA' : 'string_creation(24)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'
	
class NewOrder(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['NO_O_ID', 'NO_D_ID', 'NO_W_ID']
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'NO_O_ID'
		self.FunctionMap = {'NO_O_ID' : 'random_number_generator(1,5000)',
						'NO_D_ID' : 'random_number_generator(1,5000)',
						'NO_W_ID' : 'random_number_generator(1,5000)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'

class OrderLine(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['OL_DELIVERY_D', 'OL_QUANTITY', 'OL_AMOUNT', 'OL_DIST_INFO']
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'OL_O_ID'
		self.FunctionMap = {'OL_DELIVERY_D' : 'CURRENT_TIMESTAMP',
						'OL_QUANTITY' : 'random_number_generator_2_precision(1, 99)',
						'OL_AMOUNT' : 'random_number_generator_6_2_precision(-9999.99, 9999.99)',
						'OL_DIST_INFO' : 'string_creation(24)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'
	
class District(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['D_NAME', 'D_STREET_1', 'D_STREET_2', 'D_CITY', 'D_STATE', 'D_ZIP', 'D_TAX', 'D_YTD']
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'D_ID'
		self.FunctionMap = {'D_NAME' : 'string_creation(20)',
						'D_STREET_1' : '(string_number_creation(4) + string_creation(16))',
						'D_STREET_2' : 'string_creation(20)',
						'D_CITY' : 'string_creation(20)',
						'D_STATE' : 'string_creation(2)',
						'D_ZIP' : 'string_number_creation(9)',
						'D_TAX' : 'random_number_generator_4_4_precision(.0001, .9999)',
						'D_YTD' : 'random_number_generator_12_2_precision(-9999999999.99, 9999999999.99)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'

class Customer(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['C_FIRST', 'C_MIDDLE', 'C_LAST', 'C_STREET_1', 'C_STREET_2', 'C_CITY', 'C_STATE', 'C_ZIP', 'C_PHONE', 'C_SINCE', 'C_CREDIT', 'C_CREDIT_LIM', 'C_DISCOUNT', 'C_BALANCE', 'C_YTD_PAYMENT', 'C_PAYMENT_CNT', 'C_DELIVERY_CNT', 'C_DATA']
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'C_ID'
		self.FunctionMap = {'C_FIRST' : 'string_creation(16)',
						'C_MIDDLE' : 'string_creation(2)',
						'C_LAST' : 'string_creation(16)',
						'C_STREET_1' : '(string_number_creation(5) + string_creation(15))',
						'C_STREET_2' : 'string_creation(20)',
						'C_CITY' : 'string_creation(20)',
						'C_STATE' : 'string_creation(2)',
						'C_ZIP' : 'string_number_creation(9)',
						'C_PHONE' : 'string_number_creation(16)',
						'C_SINCE' : 'CURRENT_TIMESTAMP',
						'C_CREDIT' : 'string_creation(2)',
						'C_CREDIT_LIM' : 'random_number_generator_12_2_precision(-9999999999.99, 9999999999.99)',
						'C_DISCOUNT' : 'random_number_generator_4_4_precision(.0001, .9999)',
						'C_BALANCE' : 'random_number_generator_12_2_precision(-9999999999.99, 9999999999.99)',
						'C_YTD_PAYMENT' : 'random_number_generator_12_2_precision(-9999999999.99, 9999999999.99)',
						'C_PAYMENT_CNT' : 'random_number_generator_4_precision(-9999, 9999)',
						'C_DELIVERY_CNT' : 'random_number_generator_4_precision(-9999, 9999)',
						'C_DATA' : 'string_creation(500)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'

class OrderDetails(Table):
	def __init__(self):
		self.TypeIndicator = [1, 2]
		self.Tables = ['Warehouse', 'Stock', 'Item', 'History', 'NewOrder', 'OrderLine', 'District', 'Customer', 'OrderDetails']
		self.TransactionType = random.choice(self.TypeIndicator)
		self.TableName = random.choice(self.Tables)
		self.ColumnNames = ['OD_ENTRY_D', 'OD_OL_CNT', 'OD_ALL_LOCAL']
		self.ColumnName = random.choice(self.ColumnNames)
		self.IDName = 'OD_ID'
		self.FunctionMap = {'OD_ENTRY_D' : 'CURRENT_TIMESTAMP',
						'OD_OL_CNT' : 'random_number_generator_2_precision(0, 99)',
						'OD_ALL_LOCAL' : 'random_number_generator_1_precision(0, 9)'}
		self.FunctName = self.FunctionMap[self.ColumnName]
		self.UpdateString = 'UPDATE %s SET(%s) = %s WHERE (%s) = random_number_generator(1,5000);\n'
		self.DeleteString = 'DELETE FROM %s WHERE (%s) = random_number_generator(1,5000);\n'

f = open("Transaction.sql", "w+")		
		
for i in range(1500):
		
	LetsGo = Table()
	W1 = Warehouse() 
	S1 = Stock()
	I1 = Item() 
	H1 = History() 
	NO1 = NewOrder() 
	OL1 = OrderLine() 
	D1 = District() 
	C1 = Customer() 
	OD1 = OrderDetails()
	if LetsGo.TableName == 'Warehouse':
		f.write(W1.StringPrint())
	elif LetsGo.TableName == 'Stock':
		f.write(S1.StringPrint())
	elif LetsGo.TableName == 'Item':
		f.write(I1.StringPrint())
	elif LetsGo.TableName == 'History':
		f.write(H1.StringPrint())
	elif LetsGo.TableName == 'NewOrder':
		f.write(NO1.StringPrint())
	elif LetsGo.TableName == 'OrderLine':
		f.write(OL1.StringPrint())
	elif LetsGo.TableName == 'District':
		f.write(D1.StringPrint())
	elif LetsGo.TableName == 'Customer':
		f.write(C1.StringPrint())
	elif LetsGo.TableName == 'OrderDetails':
		f.write(OD1.StringPrint())
		
		
f.close()
	

